Time-based query | ArcGIS Maps SDK for Java | Esri Developer
View on GitHub Sample viewer app

Query data using a time extent.

Image of time-based query

Use case

This workflow can be used to return records that are between a specified start and end date. For example, records of Canada goose sightings over time could be queried to only show sightings during the winter migration time period.

How to use the sample

Run the sample, and a subset of records will be displayed on the map.

How it works

  1. Create a ServiceFeatureTable from the URL of a feature service.
  2. Set the feature table’s feature request mode to manual with featureTable.setFeatureRequestMode(MANUAL_CACHE).
  3. After loading the service feature table, create QueryParameters.
  4. Create two Calendar objects with the beginning and ending timestamps and create a TimeExtent with them.
  5. Set the time extent with queryParameters.setTimeExtent(timeExtent)
  6. Populate the table with features in the time extent with featureTable.popuateFromServiceAsync(queryParameters, true, outputFields).
    • The second argument is whether to clear the cache of features or not.
    • The output fields is a list of fields of the features to return. Use a list of one string "*" to get all of the fields.
  7. Finally, create a feature layer from the feature table with new FeatureLayer(featureTable), and add it to the map with map.getOperationalLayers().add(featureLayer) to see the features in the time extent.

Relevant API

  • QueryParameters
  • ServiceFeatureTable
  • TimeExtent

About the data

This sample uses Atlantic hurricane data from the year 2000. The data is from the National Hurricane Center (NOAA / National Weather Service).

Tags

query, time, time extent

Sample code

TimeBasedQuerySample.java
/*
* Copyright 2018 Esri.
*
* Licensed under the Apache License, Version 2.0 (the "License"); you may not
* use this file except in compliance with the License. You may obtain a copy of
* the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
* WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and limitations under
* the License.
*/
package com.esri.samples.time_based_query;
import java.util.Calendar;
import java.util.Collections;
import java.util.List;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;
import com.esri.arcgisruntime.ArcGISRuntimeEnvironment;
import com.esri.arcgisruntime.data.QueryParameters;
import com.esri.arcgisruntime.data.ServiceFeatureTable;
import com.esri.arcgisruntime.layers.FeatureLayer;
import com.esri.arcgisruntime.loadable.LoadStatus;
import com.esri.arcgisruntime.mapping.ArcGISMap;
import com.esri.arcgisruntime.mapping.BasemapStyle;
import com.esri.arcgisruntime.mapping.TimeExtent;
import com.esri.arcgisruntime.mapping.view.MapView;
public class TimeBasedQuerySample extends Application {
private MapView mapView;
private ServiceFeatureTable serviceFeatureTable; // keep loadable in scope to avoid garbage collection
@Override
public void start(Stage stage) throws Exception {
try {
// create stack pane and application scene
StackPane stackPane = new StackPane();
Scene scene = new Scene(stackPane);
// size the stage, add a title, and set scene to stage
stage.setTitle("Time Based Query Sample");
stage.setWidth(800);
stage.setHeight(700);
stage.setScene(scene);
stage.show();
// authentication with an API key or named user is required to access basemaps and other location services
String yourAPIKey = System.getProperty("apiKey");
ArcGISRuntimeEnvironment.setApiKey(yourAPIKey);
// create a map with the oceans basemap style
ArcGISMap map = new ArcGISMap(BasemapStyle.ARCGIS_OCEANS);
// create a map view and set the map to it
mapView = new MapView();
mapView.setMap(map);
// create a feature table with the URL of the feature service
String serviceURL = "https://sampleserver6.arcgisonline.com/arcgis/rest/services/Hurricanes/MapServer/0";
serviceFeatureTable = new ServiceFeatureTable(serviceURL);
// define the request mode to manual
serviceFeatureTable.setFeatureRequestMode(ServiceFeatureTable.FeatureRequestMode.MANUAL_CACHE);
// load the table and set the query
serviceFeatureTable.addDoneLoadingListener(() -> {
if (serviceFeatureTable.getLoadStatus() == LoadStatus.LOADED) {
// create query parameters
QueryParameters queryParameters = new QueryParameters();
// set a time extent (beginning of time to September 16th, 2000)
Calendar beg = new Calendar.Builder().setDate(1, 1, 1).build();
Calendar end = new Calendar.Builder().setDate(2000, 9, 16).build();
TimeExtent timeExtent = new TimeExtent(beg, end);
queryParameters.setTimeExtent(timeExtent);
// return all fields
List<String> outputFields = Collections.singletonList("*");
// populate the service with features that fit the time extent, when done zoom to the layer's extent
serviceFeatureTable.populateFromServiceAsync(queryParameters, true, outputFields).addDoneListener(() -> {
mapView.setViewpointGeometryAsync(serviceFeatureTable.getExtent());
});
} else {
new Alert(Alert.AlertType.ERROR, serviceFeatureTable.getLoadError().getMessage()).show();
}
});
// create the feature layer using the service feature table
FeatureLayer featureLayer = new FeatureLayer(serviceFeatureTable);
// add the feature layer to the map's operational layers
map.getOperationalLayers().add(featureLayer);
// add the map view to stack pane
stackPane.getChildren().addAll(mapView);
} catch (Exception e) {
// on any error, display stack trace
e.printStackTrace();
}
}
/**
* Stops and releases all resources used in application.
*/
@Override
public void stop() {
// release resources when the application closes
if (mapView != null) {
mapView.dispose();
}
}
/**
* Opens and runs application.
*
* @param args arguments passed to this application
*/
public static void main(String[] args) {
Application.launch(args);
}
}